
$FreeBSD$

--- libexec/rauth.pl.orig
+++ libexec/rauth.pl
@@ -115,11 +115,13 @@
   v.month_time_limit,
   if(v.day_time_limit=0 and v.dt='0:00:00' AND v.ut='24:00:00',
    UNIX_TIMESTAMP(DATE_FORMAT(DATE_ADD(curdate(), INTERVAL 1 MONTH), '%Y-%m-01')) - UNIX_TIMESTAMP(),
-  TIME_TO_SEC(v.ut)-TIME_TO_SEC(curtime())) as today_limit,
+  if(curtime() < v.ut, TIME_TO_SEC(v.ut)-TIME_TO_SEC(curtime()), TIME_TO_SEC('23:00:00')-TIME_TO_SEC(curtime())) 
+    ) as today_limit,
+    
   day_traf_limit,
   week_traf_limit,
   month_traf_limit,
-  if(v.hourp + v.df + v.abon=0 and sum(tt.in_price + tt.out_price)=0, 0, 1),
+  if(v.hourp + v.df + v.abon=0 and (sum(tt.in_price + tt.out_price)=0 or sum(tt.in_price + tt.out_price)IS NULL), 0, 1),
   if (count(un.uid) + count(vn.vid) = 0, 0,
     if (count(un.uid)>0, 1, 2)),
   count(tt.id),
@@ -128,17 +130,21 @@
   UNIX_TIMESTAMP(),
   UNIX_TIMESTAMP(DATE_FORMAT(FROM_UNIXTIME(UNIX_TIMESTAMP()), '%Y-%m-%d')),
   DAYOFWEEK(FROM_UNIXTIME(UNIX_TIMESTAMP())),
-  DAYOFYEAR(FROM_UNIXTIME(UNIX_TIMESTAMP()))
-     FROM users u, variant v
+  DAYOFYEAR(FROM_UNIXTIME(UNIX_TIMESTAMP())),
+  if(v.dt < v.ut,
+    if(v.dt < CURTIME() and v.ut > CURTIME(), 1, 0),
+      if((v.dt < CURTIME() or (CURTIME() > '0:00:00' and CURTIME() < v.ut ))
+       and
+       (CURTIME() < '23:00:00' or v.ut > CURTIME()  ),
+     1, 0 ))
+     FROM ( users u, variant v )
      LEFT JOIN  trafic_tarifs tt ON (tt.vid=u.variant)
      LEFT JOIN users_nas un ON (un.uid = u.uid)
      LEFT JOIN vid_nas vn ON (vn.vid = v.vrnt)
      WHERE u.variant=v.vrnt
         AND u.id='$USER'
         AND (u.expire='0000-00-00' or u.expire > CURDATE())
-        AND (u.activate='0000-00-00' or u.activate =< CURDATE())
-        AND v.dt < CURTIME()
-        AND CURTIME() < v.ut
+        AND (u.activate='0000-00-00' or u.activate <= CURDATE())
        GROUP BY u.id
 };
 
@@ -156,7 +162,15 @@
    $day_traf_limit,  $week_traf_limit,  $month_traf_limit, 
    $tp_payment,
    $nas, $traf_tarif, $time_tarif, $filter_id,
-   $session_start, $day_begin, $day_of_week, $day_of_year) = $q -> fetchrow();
+   $session_start, $day_begin, $day_of_week, $day_of_year, $allow_period) = $q -> fetchrow();
+
+#Check allow period
+# 1 - allow
+# 0 - deny
+if ($allow_period == 0) {
+   $message = "Not allow period";
+   return 1;
+}
 
 #Check allow nas server
 # $nas 1 - See user nas
@@ -208,7 +222,7 @@
 #Auth chap
 if (defined($RAD{CHAP_PASSWORD}) && defined($RAD{CHAP_CHALLENGE})) {
   if (check_chap("$RAD{CHAP_PASSWORD}", "$passwd", "$RAD{CHAP_CHALLENGE}", 0) == 0) {
-    $message = "Wrong CHAP password '$passwd'";
+    $message = "Wrong CHAP password";
     return 1;
    }      	 	
  }
@@ -287,7 +301,7 @@
 
 #Check deposit
 if($tp_payment > 0 && $deposit <= 0) {
-  $message = "User don't have money account '$deposit'. Rejected!";
+  $message = "User don't have money on account '$deposit'. Rejected!";
   return 1;
  }
 
@@ -406,6 +420,9 @@
                                                   time_limit  => $today_limit  } 
                                           )
             );
+
+
+
       }
 
 #set time limit
@@ -641,14 +658,15 @@
   	$trafic_limit = $traf_limit;
    }
 
-  $EX_PARAMS{traf_limit} = int($trafic_limit);
+  $EX_PARAMS{traf_limit} = ($trafic_limit < 1 && $trafic_limit > 0) ? 1 : int($trafic_limit);
+
 }
 
 #Local Traffic limit
 if ($trafic_limits{1} > 0) {
   #10Gb - (10240 * 1024 * 1024) - local traffic session limit
   $trafic_limit = ($trafic_limits{1} > 10240) ? 10240 :  $trafic_limits{1};
-  $EX_PARAMS{traf_limit_lo} = int($trafic_limit);
+  $EX_PARAMS{traf_limit_lo} = ($trafic_limit < 1 && $trafic_limit > 0) ? 1 : int($trafic_limit);
  }
 
  return \%EX_PARAMS;
@@ -740,7 +758,7 @@
            }
           #print "Int Begin: $int_begin Int duration: $int_duration Int prepaid: $int_prepaid Prise: $price\n";
 
-
+ 
 
           if ($int_prepaid >= $int_duration) {
             $deposit -= ($int_duration / 3600 * $price);
@@ -751,9 +769,11 @@
           elsif($int_prepaid <= $int_duration) {
             $deposit =  0;          	
             $session_start += $int_prepaid;
-            $remaining_time += $int_duration;
+            $remaining_time += $int_prepaid;
+            #print "-!! $remaining_time $int_prepaid $int_duration  \n";
             #print "DL '$deposit' ($int_prepaid <= $int_duration) $session_start\n";
            }
+          
          
         }
 
